﻿Imports Charmed.Sample.Models
Imports System.Linq

Namespace Charmed.Sample.ViewModels
	Public NotInheritable Class SplashViewModel
		Inherits ViewModelBase(Of Integer?)
		Private ReadOnly storage As IStorage
		Private ReadOnly navigator As INavigator

		Public Sub New(ByVal storage As IStorage, ByVal navigator As INavigator, ByVal serializer As ISerializer)
			MyBase.New(serializer)
			Me.storage = storage
			Me.navigator = navigator
		End Sub

		Public Overrides async Sub LoadState(ByVal navigationParameter? As Integer, ByVal pageState As Dictionary(Of String, Object))
			Me.navigator.NavigateToViewModel(Of MainViewModel)()
			Me.navigator.RemoveBackEntry()

			If navigationParameter.HasValue Then
				Dim pinnedFeedItems As List(Of FeedItem) = await storage.LoadAsync(Of List(Of FeedItem))(Constants.PinnedFeedItemsKey)
				If pinnedFeedItems IsNot Nothing Then
					Dim pinnedFeedItem = pinnedFeedItems.FirstOrDefault(Function(fi) fi.Id = navigationParameter.Value)
					If pinnedFeedItem IsNot Nothing Then
						Me.navigator.NavigateToViewModel(Of FeedItemViewModel)(pinnedFeedItem)
					End If
				End If
			End If
		End Sub
	End Class
End Namespace
