﻿Imports System.Threading.Tasks
Imports System

Namespace Charmed.Sample.Tests.Mocks
    Public NotInheritable Class MockHelper
        
        Public Shared Function ExecuteDelegate(Of TResult)(ByVal [delegate] As Func(Of TResult)) As TResult
            If [delegate] IsNot Nothing Then
                Return [delegate]()
            Else
                Return Nothing
            End If
        End Function

        Public Shared Function ExecuteDelegate(Of TParam1, TResult)(ByVal [delegate] As Func(Of TParam1, TResult), ByVal param1 As TParam1) As TResult
            If [delegate] IsNot Nothing Then
                Return [delegate](param1)
            Else
                Return Nothing
            End If
        End Function

        Public Shared Function ExecuteDelegate(Of TParam1, TParam2, TResult)(ByVal [delegate] As Func(Of TParam1, TParam2, TResult), ByVal param1 As TParam1, ByVal param2 As TParam2) As TResult
            If [delegate] IsNot Nothing Then
                Return [delegate](param1, param2)
            Else
                Return Nothing
            End If
        End Function

        Public Shared Function ExecuteDelegateAsync(Of TResult)(ByVal [delegate] As Func(Of TResult)) As Task(Of TResult)
            If [delegate] IsNot Nothing Then
                Return Task.FromResult(Of TResult)([delegate]())
            Else
                Return Task.FromResult(Of TResult)(Nothing)
            End If
        End Function

        Public Shared Function ExecuteDelegateAsync(Of TParam1, TResult)(ByVal [delegate] As Func(Of TParam1, TResult), ByVal param1 As TParam1) As Task(Of TResult)
            If [delegate] IsNot Nothing Then
                Return Task.FromResult(Of TResult)([delegate](param1))
            Else
                Return Task.FromResult(Of TResult)(Nothing)
            End If
        End Function

        Public Shared Function ExecuteDelegateAsync(Of TParam1, TParam2, TResult)(ByVal [delegate] As Func(Of TParam1, TParam2, TResult), ByVal param1 As TParam1, ByVal param2 As TParam2) As Task(Of TResult)
            If [delegate] IsNot Nothing Then
                Return Task.FromResult(Of TResult)([delegate](param1, param2))
            Else
                Return Task.FromResult(Of TResult)(Nothing)
            End If
        End Function

        Public Shared Function ExecuteDelegateAsync(Of TParam1, TParam2, TParam3, TResult)(ByVal [delegate] As Func(Of TParam1, TParam2, TParam3, TResult), ByVal param1 As TParam1, ByVal param2 As TParam2, ByVal param3 As TParam3) As Task(Of TResult)
            If [delegate] IsNot Nothing Then
                Return Task.FromResult(Of TResult)([delegate](param1, param2, param3))
            Else
                Return Task.FromResult(Of TResult)(Nothing)
            End If
        End Function
    End Class
End Namespace
