﻿Imports System.Threading.Tasks
Imports System

Namespace Charmed.Sample.Tests.Mocks
    Public Class SecondaryPinnerMock
        Implements ISecondaryPinner
        Public Property PinDelegate As Func(Of TileInfo, Boolean)
        Public Function Pin(ByVal tileInfo As TileInfo) As Task(Of Boolean) Implements ISecondaryPinner.Pin
            Return MockHelper.ExecuteDelegateAsync(Of TileInfo, Boolean)(Me.PinDelegate, tileInfo)
        End Function

        Public Property UnpinDelegate As Func(Of TileInfo, Boolean)
        Public Function Unpin(ByVal tileInfo As TileInfo) As Task(Of Boolean) Implements ISecondaryPinner.Unpin
            Return MockHelper.ExecuteDelegateAsync(Of TileInfo, Boolean)(Me.UnpinDelegate, tileInfo)
        End Function

        Public Property IsPinnedDelegate As Func(Of String, Boolean)
        Public Function IsPinned(ByVal tileId As String) As Boolean Implements ISecondaryPinner.IsPinned
            Return MockHelper.ExecuteDelegate(Of String, Boolean)(Me.IsPinnedDelegate, tileId)
        End Function
    End Class
End Namespace
