﻿Imports System.Threading.Tasks
Imports System

Namespace Charmed.Sample.Tests.Mocks
    Public Class StorageMock
        Implements IStorage
        Public Property LoadAsyncDelegate As Func(Of String, Object)
        Public Function LoadAsync(Of T)(ByVal fileName As String) As Task(Of T) Implements IStorage.LoadAsync
            If Me.LoadAsyncDelegate IsNot Nothing Then
                Return Task.FromResult(Of T)(CType(Me.LoadAsyncDelegate(fileName), T))
            Else
                Return Task.FromResult(Of T)(Nothing)
            End If
        End Function

        Public Property SaveAsyncDelegate As Action(Of String, Object)
        Public Function SaveAsync(ByVal fileName As String, ByVal data As Object) As Task Implements IStorage.SaveAsync
            Return Task.Run(Sub()
                                If Me.SaveAsyncDelegate IsNot Nothing Then
                                    Me.SaveAsyncDelegate()(fileName, data)
                                End If
                            End Sub)
        End Function
    End Class
End Namespace
