﻿Imports Charmed.Sample.Models
Imports System.Threading.Tasks

Namespace Charmed.Sample.Services
	''' <summary>
	''' Service to read RSS feeds.
	''' </summary>
	''' <remarks>
	''' The idea behind this class is mostly borrowed from Windows Store Blog Reader Sample
	''' http://msdn.microsoft.com/en-us/library/windows/apps/br211380.aspx
	''' </remarks>
	Public MustInherit Class RssFeedService
		Implements IRssFeedService
		Protected ReadOnly settings As ISettings

		Public Sub New(ByVal settings As ISettings)
			Me.settings = settings
		End Sub

		Public async Function GetFeedsAsync() As Task(Of List(Of FeedData)) Implements IRssFeedService.GetFeedsAsync
			Dim feeds As List(Of String) = Nothing
            Dim feedData() As String = Nothing
			If settings.TryGetValue(Of String())(Constants.FeedsKey, feedData) Then
				feeds = New List(Of String)(feedData)
			Else
				Throw New ArgumentException("There are no feeds")
			End If

            Dim feedsData As List(Of FeedData) = New List(Of FeedData)()

            For Each feed As String In feeds
                Dim data As FeedData = Await GetFeedAsync(feed)
                If data IsNot Nothing Then
                    feedsData.Add(data)
                End If
            Next feed

			Return feedsData
		End Function

		Protected MustOverride Function GetFeedAsync(ByVal feedUriString As String) As Task(Of FeedData)
	End Class
End Namespace
