﻿Imports Charmed.Helpers
Imports Charmed.Messaging
Imports Charmed.Sample.Messages
Imports Charmed.Sample.Models
Imports Charmed.Sample.Services

Namespace Charmed.Sample.ViewModels
	Public NotInheritable Class MainViewModel
		Inherits ViewModelBase
		Private ReadOnly rssFeedService As IRssFeedService
		Private ReadOnly navigator As INavigator
		Private ReadOnly messageBus As IMessageBus

		Public Sub New(ByVal rssFeedService As IRssFeedService, ByVal navigator As INavigator, ByVal messageBus As IMessageBus)
			Me.rssFeedService = rssFeedService
			Me.navigator = navigator
			Me.messageBus = messageBus

			Me.messageBus.Subscribe(Of FeedsChangedMessage)(Sub(message) LoadFeedData())
		End Sub

		Public Sub ViewFeed(ByVal feedItem As FeedItem)
			Me.navigator.NavigateToViewModel(Of FeedItemViewModel)(feedItem)
		End Sub

		Private Sub LoadFeedData()
			Me.IsBusy = True
            AsyncHelper.LoadData(Sub(f)
                                     Me.FeedData = f
                                     Me.IsBusy = False
                                 End Sub,
                                 AddressOf Me.rssFeedService.GetFeedsAsync)
		End Sub

'INSTANT VB NOTE: The variable feedData was renamed since Visual Basic does not allow class members with the same name:
		Private feedData_Renamed As List(Of FeedData)
        Public Property FeedData As List(Of FeedData)
            Get
                If Me.feedData_Renamed Is Nothing AndAlso (Not Me.IsBusy) Then
                    LoadFeedData()
                End If

                Return Me.feedData_Renamed
            End Get
            Private Set(ByVal value As List(Of FeedData))
                Me.SetProperty(Me.feedData_Renamed, value)
            End Set
        End Property
	End Class
End Namespace
