﻿Imports Callisto.Controls
Imports Charmed.Sample.Models
Imports Charmed.Sample.Win8.Views
Imports Windows.UI.ApplicationSettings
Imports Windows.UI.Xaml

Namespace Charmed.Sample.ViewModels
	Public NotInheritable Class ShellViewModel
		Inherits ViewModelBase
		Private ReadOnly settingsManager As ISettingsManager
		Private ReadOnly settings As ISettings

		Public Sub New(ByVal settingsManager As ISettingsManager, ByVal settings As ISettings)
			Me.settingsManager = settingsManager
			Me.settings = settings
		End Sub

		Public Sub Initialize()
			Me.settingsManager.Initialize()
			Me.settingsManager.OnSettingsRequested = AddressOf OnSettingsRequested

			If Not Me.settings.ContainsKey(Constants.FeedsKey) Then
				' Seed the app with default feeds.
                Dim feeds() As String = {"http://blogs.windows.com/windows/b/windowsexperience/atom.aspx", "http://blogs.windows.com/windows/b/extremewindows/atom.aspx", "http://blogs.windows.com/windows/b/bloggingwindows/atom.aspx", "http://blogs.windows.com/windows_live/b/windowslive/rss.aspx", "http://blogs.windows.com/windows_live/b/developer/atom.aspx", "http://blogs.windows.com/windows_phone/b/wpdev/atom.aspx", "http://blogs.windows.com/windows_phone/b/wmdev/atom.aspx", "http://blogs.windows.com/windows_phone/b/windowsphone/atom.aspx"}

				Me.settings.AddOrUpdate(Constants.FeedsKey, feeds)
			End If
		End Sub

		Public Sub Cleanup()
			Me.settingsManager.Cleanup()
		End Sub

		Private Sub OnSettingsRequested(ByVal commands As IList(Of SettingsCommand))
            Dim settingsCommand As New SettingsCommand("FeedsSetting", "Feeds", Sub(x)
                                                                                    Dim settings As New SettingsFlyout
                                                                                    settings.FlyoutWidth = Callisto.Controls.SettingsFlyout.SettingsFlyoutWidth.Wide
                                                                                    settings.HeaderText = "Feeds"
                                                                                    Dim view As SettingsView = New SettingsView
                                                                                    settings.Content = view
                                                                                    settings.HorizontalContentAlignment = HorizontalAlignment.Stretch
                                                                                    settings.VerticalContentAlignment = VerticalAlignment.Stretch
                                                                                    settings.IsOpen = True
                                                                                End Sub)
			commands.Add(settingsCommand)
		End Sub
	End Class
End Namespace
