﻿Imports Charmed.Container
Imports Charmed.Helpers
Imports Charmed.Messaging
Imports Charmed.Sample.Services

Namespace Charmed.Sample.ViewModels
	Public NotInheritable Class ViewModelLocator
		Public Sub New()
			Ioc.Container.Register(Of MainViewModel)()

			Ioc.Container.Register(Of ISerializer, Serializer)()
			Ioc.Container.Register(Of ISettings, Settings)()
			Ioc.Container.Register(Of IStorage, Storage)()
			Ioc.Container.RegisterInstance(Of IMessageBus)(New MessageBus())
			Ioc.Container.RegisterInstance(Of IContainer)(Ioc.Container)

#If NETFX_CORE Then
			Ioc.Container.Register(Of FeedItemViewModel, Win8FeedItemViewModel)()

			Ioc.Container.Register(Of ISecondaryPinner, Win8SecondaryPinner)()

			Ioc.Container.Register(Of INavigator, Navigator)()
			Ioc.Container.Register(Of IRssFeedService, Win8RssFeedService)()
			Ioc.Container.Register(Of ShellViewModel)()
			Ioc.Container.Register(Of IShareManager, ShareManager)()
			Ioc.Container.Register(Of ISettingsManager, SettingsManager)()
			Ioc.Container.Register(Of SettingsViewModel)()
#Else
			Ioc.Container.Register(Of ISecondaryPinner, WP8SecondaryPinner)()
			Ioc.Container.Register(Of IRssFeedService, WP8RssFeedService)()
			Ioc.Container.Register(Of FeedItemViewModel, WP8FeedItemViewModel)()
			Ioc.Container.Register(Of SplashViewModel)()
#End If ' NETFX_CORE
		End Sub

        Public ReadOnly Property Main As MainViewModel
            Get
                Return Ioc.Container.Resolve(Of MainViewModel)()
            End Get
        End Property

        Public ReadOnly Property FeedItem As FeedItemViewModel
            Get
                Return Ioc.Container.Resolve(Of FeedItemViewModel)()
            End Get
        End Property

#If NETFX_CORE Then
        Public ReadOnly Property Settings As SettingsViewModel
            Get
                Return Ioc.Container.Resolve(Of SettingsViewModel)()
            End Get
        End Property
#Else
		Public ReadOnly Property Splash As SplashViewModel
			Get
				Return Ioc.Container.Resolve(Of SplashViewModel)()
			End Get
		End Property
#End If ' NETFX_CORE

        Public Shared ReadOnly Property IsInDesignMode As Boolean
            Get
#If NETFX_CORE Then
                Return Windows.ApplicationModel.DesignMode.DesignModeEnabled
#Else
				Return System.ComponentModel.DesignerProperties.IsInDesignTool
#End If ' NETFX_CORE
            End Get
        End Property
	End Class
End Namespace
