﻿Imports Microsoft.Phone.Shell
Imports System

Namespace Charmed.ApplicationBar
    ''' <summary>
    ''' Application Bar Icon Button that allows for routing the click to a method on the view model.
    ''' </summary>
    Public NotInheritable Class BindableApplicationBarIconButton
        Inherits ApplicationBarIconButton
        Public Sub New()
            MyBase.New()
            AddHandler Me.Click, AddressOf OnClick
        End Sub

        Private Sub OnClick(ByVal sender As Object, ByVal e As EventArgs)
            If Me.DataContext IsNot Nothing Then
                Dim clickMethod = Me.DataContext.GetType.GetMethod(Me.ClickMethodName)

                Dim parms = clickMethod.GetParameters
                If Me.DataItem IsNot Nothing AndAlso parms IsNot Nothing AndAlso parms.Length = 1 Then
                    Dim param = parms(0)
                    Dim paramType = param.ParameterType

                    Dim dataItemType = Me.DataItem.GetType
                    If dataItemType IsNot paramType Then
                        Throw New ArgumentException("DataItem is the wrong type.")
                    End If

                    clickMethod.Invoke(Me.DataContext, {Me.DataItem})
                Else
                    clickMethod.Invoke(Me.DataContext, Nothing)
                End If
            End If
        End Sub

        Public Property ClickMethodName As String
        Public Property DataContext As Object
        Public Property DataItem As Object
    End Class
End Namespace
