﻿Imports Microsoft.Phone.Controls
Imports System.Reflection
Imports System.Windows

Namespace Charmed.Helpers
    ''' <summary>
    ''' Helper class for routing a LongListSelector's SelectionChangeds to a method on the view model.
    ''' </summary>
    Public NotInheritable Class LongListSelectorHelper
        Public Shared ReadOnly SelectionChangedMethodNameProperty As DependencyProperty = DependencyProperty.RegisterAttached("SelectionChangedMethodName", GetType(String),
                                                                                                                              GetType(LongListSelectorHelper), New PropertyMetadata(Nothing, New PropertyChangedCallback(Sub(sender, args)
                                                                                                                                                                                                                             Dim longListSelector1 As LongListSelector = TryCast(sender, LongListSelector)
                                                                                                                                                                                                                             If longListSelector1 IsNot Nothing Then
                                                                                                                                                                                                                                 If Not (TypeOf longListSelector1.Tag Is LongListSelectorHelper) Then
                                                                                                                                                                                                                                     Dim TempLongListSelectorHelper As LongListSelectorHelper = New LongListSelectorHelper(longListSelector1)
                                                                                                                                                                                                                                 End If
                                                                                                                                                                                                                             End If
                                                                                                                                                                                                                         End Sub)))

        Public Shared ReadOnly MethodContextProperty As DependencyProperty = DependencyProperty.RegisterAttached("MethodContext",
                                                                                                                 GetType(Object), GetType(LongListSelectorHelper), New PropertyMetadata(Nothing, New PropertyChangedCallback(Sub(sender, args)
                                                                                                                                                                                                                                 Dim longListSelector1 = TryCast(sender, LongListSelector)
                                                                                                                                                                                                                                 If longListSelector1 IsNot Nothing Then
                                                                                                                                                                                                                                     If Not (TypeOf longListSelector1.Tag Is LongListSelectorHelper) Then
                                                                                                                                                                                                                                         longListSelector1.Tag = New LongListSelectorHelper(longListSelector1)
                                                                                                                                                                                                                                     End If
                                                                                                                                                                                                                                 End If
                                                                                                                                                                                                                             End Sub)))

        Public Sub New(ByVal longListSelector As LongListSelector)
            AddHandler longListSelector.SelectionChanged, Sub(sender, args)
                                                                       Dim methodName = GetSelectionChangedMethodName(longListSelector)

                                                                       Dim dataContext = GetMethodContext(longListSelector)
                                                                       If dataContext Is Nothing Then
                                                                           dataContext = longListSelector.DataContext
                                                                       End If

                                                                       Dim method = dataContext.GetType.GetTypeInfo.GetDeclaredMethod(methodName)
                                                                       Dim parms = method.GetParameters

                                                                       If parms IsNot Nothing AndAlso parms.Length = 1 Then
                                                                           method.Invoke(dataContext, {longListSelector.SelectedItem})
                                                                       Else
                                                                           method.Invoke(dataContext, Nothing)
                                                                       End If
                                                                   End Sub
        End Sub

        Public Shared Sub SetSelectionChangedMethodName(ByVal element As LongListSelector, ByVal itemClickMethodName As String)
            element.SetValue(SelectionChangedMethodNameProperty, itemClickMethodName)
        End Sub

        Public Shared Function GetSelectionChangedMethodName(ByVal element As LongListSelector) As String
            Return CStr(element.GetValue(SelectionChangedMethodNameProperty))
        End Function

        Public Shared Sub SetMethodContext(ByVal element As LongListSelector, ByVal value As Object)
            element.SetValue(MethodContextProperty, value)
        End Sub
        Public Shared Function GetMethodContext(ByVal element As LongListSelector) As Object
            Return element.GetValue(MethodContextProperty)
        End Function
    End Class
End Namespace
