﻿Imports Microsoft.Phone.Shell
Imports System.Linq
Imports System.Threading.Tasks
Imports System

Namespace Charmed
    Public NotInheritable Class WP8SecondaryPinner
        Implements ISecondaryPinner
        Public Function Pin(ByVal tileInfo As TileInfo) As Task(Of Boolean) Implements ISecondaryPinner.Pin
            Dim result = False
            If Not Me.IsPinned(tileInfo.TileId) Then
                Dim tileData = New StandardTileData With {.Title = tileInfo.DisplayName, .BackgroundImage = tileInfo.LogoUri, .Count = tileInfo.Count, .BackTitle = tileInfo.AppName, .BackBackgroundImage = New Uri("", UriKind.Relative), .BackContent = tileInfo.DisplayName}

                ShellTile.Create(New Uri(tileInfo.TileId, UriKind.Relative), tileData)
                result = True
            End If

            Return Task.FromResult(Of Boolean)(result)
        End Function

        Public Function Unpin(ByVal tileInfo As TileInfo) As Task(Of Boolean) Implements ISecondaryPinner.Unpin
            Dim tile As ShellTile = Me.FindTile(tileInfo.TileId)
            If tile IsNot Nothing Then
                tile.Delete()
            End If

            Return Task.FromResult(Of Boolean)(True)
        End Function

        Public Function IsPinned(ByVal tileId As String) As Boolean Implements ISecondaryPinner.IsPinned
            Return FindTile(tileId) IsNot Nothing
        End Function

        Private Function FindTile(ByVal uri As String) As ShellTile
            Return ShellTile.ActiveTiles.FirstOrDefault(Function(tile) tile.NavigationUri.ToString = uri)
        End Function
    End Class
End Namespace
