﻿Imports Charmed.Converters
Imports Microsoft.VisualStudio.TestPlatform.UnitTestFramework
Imports Windows.UI.Xaml
Imports System

Namespace Charmed.Tests.Converters
    <TestClass>
    Public Class BoolToVisibilityConverterTests
        <TestMethod>
        Public Sub Convert_True()
            ' Arrange
            Dim converter As BoolToVisibilityConverter = New BoolToVisibilityConverter()

            ' Act
            Dim result As Visibility = CType(converter.Convert(True, Nothing, Nothing, Nothing), Visibility)

            ' Assert
            Assert.AreEqual(Visibility.Visible, result)
        End Sub

        <TestMethod>
        Public Sub Convert_False()
            ' Arrange
            Dim converter As BoolToVisibilityConverter = New BoolToVisibilityConverter()

            ' Act
            Dim result As Visibility = CType(converter.Convert(False, Nothing, Nothing, Nothing), Visibility)

            ' Assert
            Assert.AreEqual(Visibility.Collapsed, result)
        End Sub

        <TestMethod>
        Public Sub Convert_NotBool()
            ' Arrange
            Dim converter As BoolToVisibilityConverter = New BoolToVisibilityConverter()

            ' Act
            Dim result As Visibility = CType(converter.Convert(New Object(), Nothing, Nothing, Nothing), Visibility)

            ' Assert
            Assert.AreEqual(Visibility.Collapsed, result)
        End Sub

        <TestMethod>
        Public Sub ConvertBack()
            ' Arrange
            Dim converter As BoolToVisibilityConverter = New BoolToVisibilityConverter()

            ' Act

            ' Assert
            Assert.ThrowsException(Of NotImplementedException)(Function() converter.ConvertBack(Nothing, Nothing, Nothing, Nothing))
        End Sub
    End Class
End Namespace
