﻿Imports Charmed.Converters
Imports Microsoft.VisualStudio.TestPlatform.UnitTestFramework

Namespace Charmed.Tests.Converters
	<TestClass>
	Public Class InverseBoolConverterTests
		<TestMethod>
		Public Sub Convert_True()
			' Arrange
            Dim converter As InverseBoolConverter = New InverseBoolConverter()

			' Act
            Dim result As Boolean = CBool(converter.Convert(True, Nothing, Nothing, Nothing))

			' Assert
			Assert.IsFalse(result)
		End Sub

		<TestMethod>
		Public Sub Convert_False()
			' Arrange
            Dim converter As InverseBoolConverter = New InverseBoolConverter()

			' Act
            Dim result As Boolean = CBool(converter.Convert(False, Nothing, Nothing, Nothing))

			' Assert
			Assert.IsTrue(result)
		End Sub

		<TestMethod>
		Public Sub Convert_NotBool()
			' Arrange
            Dim converter As InverseBoolConverter = New InverseBoolConverter()

			' Act
            Dim result As Boolean = CBool(converter.Convert(New Object(), Nothing, Nothing, Nothing))

			' Assert
			Assert.IsFalse(result)
		End Sub

		<TestMethod>
		Public Sub ConvertBack_True()
			' Arrange
            Dim converter As InverseBoolConverter = New InverseBoolConverter()

			' Act
            Dim result As Boolean = CBool(converter.ConvertBack(True, Nothing, Nothing, Nothing))

			' Assert
			Assert.IsFalse(result)
		End Sub

		<TestMethod>
		Public Sub ConvertBack_False()
			' Arrange
            Dim converter As InverseBoolConverter = New InverseBoolConverter()

			' Act
            Dim result As Boolean = CBool(converter.ConvertBack(False, Nothing, Nothing, Nothing))

			' Assert
			Assert.IsTrue(result)
		End Sub

		<TestMethod>
		Public Sub ConvertBack_NotBool()
			' Arrange
            Dim converter As InverseBoolConverter = New InverseBoolConverter()

			' Act
            Dim result As Boolean = CBool(converter.ConvertBack(New Object(), Nothing, Nothing, Nothing))

			' Assert
			Assert.IsFalse(result)
		End Sub
	End Class
End Namespace
