﻿Imports Charmed.Container
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks

Namespace Charmed.Container
	Public NotInheritable Class Ioc
		Private Shared _container As IContainer
		Private Shared _lock As New Object()

        Public Shared Property Container As IContainer
            Get
                If _container Is Nothing Then
                    SyncLock _lock
                        If _container Is Nothing Then
                            _container = New SimpleContainer()
                        End If
                    End SyncLock
                End If

                Return _container
            End Get
            Set(ByVal value As IContainer)
                SyncLock _lock
                    _container = value
                End SyncLock
            End Set
        End Property
	End Class
End Namespace
