﻿Imports System

#If WINDOWS_PHONE Then
Imports System.Windows.Data
#Else
Imports Windows.UI.Xaml.Data
#End If ' WINDOWS_PHONE

Namespace Charmed.Converters
    ''' <summary>
    ''' Converts a DateTime to a string value.
    ''' </summary>
    Public NotInheritable Class DateTimeToStringConverter
        Implements IValueConverter
        Public Property Format As String
        Public Property IsDateTimeNullable As Boolean

#If WINDOWS_PHONE Then
        Public Function Convert(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As System.Globalization.CultureInfo) As Object Implements IValueConverter.Convert
#Else
        Public Function Convert(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal language As String) As Object Implements IValueConverter.Convert
#End If ' WINDOWS_PHONE
            Dim result As String = String.Empty
            If TypeOf value Is Date Then
                result = (CDate(value)).ToString(If(Me.Format, "d"))
            End If

            Return result
        End Function

#If WINDOWS_PHONE Then
        Public Function ConvertBack(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As System.Globalization.CultureInfo) As Object Implements IValueConverter.ConvertBack
#Else
        Public Function ConvertBack(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal language As String) As Object Implements IValueConverter.ConvertBack
#End If ' WINDOWS_PHONE
            Dim [date] As Date
            If value IsNot Nothing AndAlso Date.TryParse(value.ToString, [date]) Then
                Return [date]
            Else
                If Me.IsDateTimeNullable Then
                    Return Nothing
                Else
                    Return New Date()
                End If
            End If
        End Function
    End Class
End Namespace
