﻿Imports System

#If WINDOWS_PHONE Then
Imports System.Windows.Data
Imports System.Windows
#Else
Imports Windows.UI.Xaml
Imports Windows.UI.Xaml.Data
#End If ' WINDOWS_PHONE

Namespace Charmed.Converters
    ''' <summary>
    ''' Inverts a boolean and converts it to a Visibility.
    ''' </summary>
    Public NotInheritable Class InverseBoolToVisibilityConverter
        Implements IValueConverter
#If WINDOWS_PHONE Then
        Public Function Convert(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As System.Globalization.CultureInfo) As Object Implements IValueConverter.Convert
#Else
        Public Function Convert(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal language As String) As Object Implements IValueConverter.Convert
#End If ' WINDOWS_PHONE
            Dim result As Integer = Visibility.Collapsed
            If TypeOf value Is Boolean Then
                result = If(CBool(value), Visibility.Collapsed, Visibility.Visible)
            End If

            Return result
        End Function

#If WINDOWS_PHONE Then
        Public Function ConvertBack(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As System.Globalization.CultureInfo) As Object Implements IValueConverter.ConvertBack
#Else
        Public Function ConvertBack(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal language As String) As Object Implements IValueConverter.ConvertBack
#End If ' WINDOWS_PHONE
            Throw New NotImplementedException()
        End Function
    End Class
End Namespace
