﻿Imports System.Linq
Imports System.Text
Imports System.Reflection
Imports System.Threading.Tasks
Imports Windows.UI.Xaml
Imports Windows.UI.Xaml.Controls

Namespace Charmed.Helpers
	''' <summary>
	''' Helper class for routing a Button's Clicks to a method on the view model.
	''' </summary>
	Public NotInheritable Class ButtonHelper
        Public Shared ReadOnly MethodNameProperty As DependencyProperty = DependencyProperty.RegisterAttached("MethodName", GetType(String), GetType(ButtonHelper), New PropertyMetadata(Nothing, New PropertyChangedCallback(Sub(sender, args)
                                                                                                                                                                                                                                  Dim button1 As Button = TryCast(sender, Button)
                                                                                                                                                                                                                                  If button1 IsNot Nothing Then
                                                                                                                                                                                                                                      If Not (TypeOf button1.Tag Is ButtonHelper) Then
                                                                                                                                                                                                                                          button1.Tag = New ButtonHelper(button1)
                                                                                                                                                                                                                                      End If
                                                                                                                                                                                                                                  End If
                                                                                                                                                                                                                              End Sub)))

        Public Shared ReadOnly ParameterProperty As DependencyProperty = DependencyProperty.RegisterAttached("Parameter", GetType(Object), GetType(ButtonHelper), New PropertyMetadata(Nothing, New PropertyChangedCallback(Sub(sender, args)
                                                                                                                                                                                                                                Dim button1 As Button = TryCast(sender, Button)
                                                                                                                                                                                                                                If button1 IsNot Nothing Then
                                                                                                                                                                                                                                    If Not (TypeOf button1.Tag Is ButtonHelper) Then
                                                                                                                                                                                                                                        button1.Tag = New ButtonHelper(button1)
                                                                                                                                                                                                                                    End If
                                                                                                                                                                                                                                End If
                                                                                                                                                                                                                            End Sub)))

        Public Shared ReadOnly MethodContextProperty As DependencyProperty = DependencyProperty.RegisterAttached("MethodContext", GetType(Object), GetType(ButtonHelper), New PropertyMetadata(Nothing, New PropertyChangedCallback(Sub(sender, args)
                                                                                                                                                                                                                                        Dim button1 As Button = TryCast(sender, Button)
                                                                                                                                                                                                                                        If button1 IsNot Nothing Then
                                                                                                                                                                                                                                            If Not (TypeOf button1.Tag Is ButtonHelper) Then
                                                                                                                                                                                                                                                button1.Tag = New ButtonHelper(button1)
                                                                                                                                                                                                                                            End If
                                                                                                                                                                                                                                        End If
                                                                                                                                                                                                                                    End Sub)))

		Public Sub New(ByVal button As Button)
            AddHandler button.Click, Sub(o, a)
                                         Dim methodName As String = GetMethodName(button)

                                         Dim dataContext As Object = GetMethodContext(button)
                                         If dataContext Is Nothing Then
                                             dataContext = button.DataContext
                                         End If

                                         Dim method As MethodInfo = dataContext.GetType.GetTypeInfo.GetDeclaredMethod(methodName)
                                         Dim parms As System.Reflection.ParameterInfo() = method.GetParameters

                                         Dim parameters() As Object = Nothing

                                         If parms IsNot Nothing AndAlso parms.Length > 0 Then
                                             parameters = New Object(parms.Length - 1) {}
                                             If parms(0).ParameterType.GetTypeInfo.IsAssignableFrom(o.GetType.GetTypeInfo) Then
                                                 ' The first parameter must be the clicked button.
                                                 parameters(0) = o
                                             Else
                                                 ' The first parameter must be the ClickParameter
                                                 parameters(0) = GetParameter(button)
                                             End If

                                             If parms.Length = 2 Then
                                                 ' The second parameter must be the ClickParameter
                                                 parameters(1) = GetParameter(button)
                                             End If
                                         End If

                                         method.Invoke(dataContext, parameters)
                                     End Sub
		End Sub

		Public Shared Sub SetMethodName(ByVal element As Button, ByVal value As String)
			element.SetValue(MethodNameProperty, value)
		End Sub
		Public Shared Function GetMethodName(ByVal element As Button) As String
			Return CStr(element.GetValue(MethodNameProperty))
		End Function

		Public Shared Sub SetParameter(ByVal element As Button, ByVal value As Object)
			element.SetValue(ParameterProperty, value)
		End Sub
		Public Shared Function GetParameter(ByVal element As Button) As Object
			Return element.GetValue(ParameterProperty)
		End Function

		Public Shared Sub SetMethodContext(ByVal element As Button, ByVal value As Object)
			element.SetValue(MethodContextProperty, value)
		End Sub
		Public Shared Function GetMethodContext(ByVal element As Button) As Object
			Return element.GetValue(MethodContextProperty)
		End Function
	End Class
End Namespace
