﻿Namespace Charmed
	''' <summary>
	''' Interface for navigation in an application.
	''' </summary>
	Public Interface INavigator
		''' <summary>
		''' Gets whether there is a previous page to go back to.
		''' </summary>
        ReadOnly Property CanGoBack As Boolean

		''' <summary>
		''' Goes back to the previous page.
		''' </summary>
		Sub GoBack()

		''' <summary>
		''' Navigates to the page for a given view model.
		''' </summary>
		''' <typeparam name="TViewModel">The type of view model to navigate to.</typeparam>
		''' <param name="parameter">An optional navigation parameter.</param>
		Sub NavigateToViewModel(Of TViewModel)(Optional ByVal parameter As Object = Nothing)

#If WINDOWS_PHONE Then
		''' <summary>
		''' Removes the back entry.
		''' </summary>
		Sub RemoveBackEntry()
#End If ' WINDOWS_PHONE
	End Interface
End Namespace
