﻿Imports System.Threading.Tasks

Namespace Charmed
	''' <summary>
	''' Interface for pinning a secondary tile.
	''' </summary>
	Public Interface ISecondaryPinner
		''' <summary>
		''' Pins a secondary tile.
		''' </summary>
		''' <param name="tileInfo">The TileInfo object containing all the information about the tile to pin.</param>
		''' <returns>Returns true if the tile was pinned and false if it was not pinned.</returns>
		Function Pin(ByVal tileInfo As TileInfo) As Task(Of Boolean)

		''' <summary>
		''' Unpins a secondary tile.
		''' </summary>
		''' <param name="tileInfo">The TileInfo object containing all the information about the tile to unpin.</param>
		''' <returns>Returns true if the tile was unpinned and false if it was not unpinned.</returns>
		Function Unpin(ByVal tileInfo As TileInfo) As Task(Of Boolean)

		''' <summary>
		''' Checks if a tile is already pinned.
		''' </summary>
		''' <param name="tileId">The Id of the tile to check for.</param>
		''' <returns>Returns true if the tile is already pinned and false if not.</returns>
		Function IsPinned(ByVal tileId As String) As Boolean
	End Interface
End Namespace
