﻿Imports System

Namespace Charmed
    ''' <summary>
    ''' An interface for serializing and deserializing objects.
    ''' </summary>
    Public Interface ISerializer
        ''' <summary>
        ''' Deserializes an object from a string.
        ''' </summary>
        ''' <param name="type">The type of object to deserialize.</param>
        ''' <param name="data">The string data to use for deserialization.</param>
        ''' <returns>Returns the deserialized object.</returns>
        Function Deserialize(ByVal type As Type, ByVal data As String) As Object

        ''' <summary>
        ''' Deserializes an object.
        ''' </summary>
        ''' <typeparam name="T">The type of object to deserialize.</typeparam>
        ''' <param name="data">The string data to use for deserialization.</param>
        ''' <returns>Returns the deserialized object.</returns>
        Function Deserialize(Of T)(ByVal data As String) As T

        ''' <summary>
        ''' Serializes an object to a string.
        ''' </summary>
        ''' <param name="instance">The object to serialize.</param>
        ''' <returns>Returns the object serialized as a string.</returns>
        Function Serialize(ByVal instance As Object) As String
    End Interface
End Namespace
