﻿Imports System.Threading.Tasks

Namespace Charmed
	''' <summary>
	''' Interface for saving data to local storage.
	''' </summary>
	Public Interface IStorage
		''' <summary>
		''' Loads data from local storage with the given file name.
		''' </summary>
		''' <typeparam name="T">The type of data to load.</typeparam>
		''' <param name="fileName">The name of the file to load data from.</param>
		''' <returns>Returns the loaded data or null if the file was not found.</returns>
		Function LoadAsync(Of T)(ByVal fileName As String) As Task(Of T)

		''' <summary>
		''' Saves data to local storage with the given file name.
		''' </summary>
		''' <param name="fileName">The name fo the file to save data to.</param>
		''' <param name="data">The data to save.</param>
		''' <returns></returns>
		Function SaveAsync(ByVal fileName As String, ByVal data As Object) As Task
	End Interface
End Namespace
