﻿Imports System

Namespace Charmed.Messaging
    ''' <summary>
    '''	Maintains a weak reference to an action/delegate.
    ''' </summary>
    Public NotInheritable Class ActionReference
        Private Property WeakReference As WeakReference

        ''' <summary>
        ''' Gets the action/delegate this reference targets.
        ''' </summary>
        Private privateTarget As [Delegate]
        Public Property Target As [Delegate]
            Get
                Return privateTarget
            End Get
            Private Set(ByVal value As [Delegate])
                privateTarget = value
            End Set
        End Property

        ''' <summary>
        ''' Gets whether the reference is still alive.
        ''' </summary>
        Public ReadOnly Property IsAlive As Boolean
            Get
                Return WeakReference.IsAlive
            End Get
        End Property

        ''' <summary>
        ''' Constructor for ActionReference.
        ''' </summary>
        ''' <param name="action">The action/delegate to be referenced.</param>
        Public Sub New(ByVal action As [Delegate])
            Target = action
            WeakReference = New WeakReference(action.Target)
        End Sub
    End Class
End Namespace
