﻿Imports System.IO
Imports System.Runtime.Serialization.Json
Imports System.Text
Imports System

Namespace Charmed
    Public NotInheritable Class Serializer
        Implements ISerializer
        Public Function Deserialize(ByVal type As Type, ByVal json As String) As Object Implements ISerializer.Deserialize
            Dim decoded As String = System.Net.WebUtility.UrlDecode(json)
            Dim bytes() As Byte = Encoding.Unicode.GetBytes(decoded)
            Using stream As New MemoryStream(bytes)
                Dim serializer As DataContractJsonSerializer = New DataContractJsonSerializer(type)
                Return serializer.ReadObject(stream)
            End Using
        End Function

        Public Function Deserialize(Of T)(ByVal json As String) As T Implements ISerializer.Deserialize
            Return CType(Deserialize(GetType(T), json), T)
        End Function

        Public Function Serialize(ByVal instance As Object) As String Implements ISerializer.Serialize
            If instance Is Nothing Then
                Throw New ArgumentNullException("instance")
            End If

            Using stream As New MemoryStream()
                Dim serializer As DataContractJsonSerializer = New DataContractJsonSerializer(instance.GetType)
                serializer.WriteObject(stream, instance)
                stream.Position = 0
                Using reader As New StreamReader(stream)
                    Dim serialized As String = reader.ReadToEnd
                    Dim urlEncoded As String = System.Net.WebUtility.UrlEncode(serialized)
                    Return urlEncoded
                End Using
            End Using
        End Function
    End Class
End Namespace
