﻿#If WINDOWS_PHONE Then
Imports System.IO.IsolatedStorage
#End If ' WINDOWS_PHONE

Imports Windows.Storage

Namespace Charmed
	Public NotInheritable Class Settings
		Implements ISettings
		Public Sub AddOrUpdate(ByVal key As String, ByVal value As Object) Implements ISettings.AddOrUpdate
#If WINDOWS_PHONE Then
			IsolatedStorageSettings.ApplicationSettings(key) = value
			IsolatedStorageSettings.ApplicationSettings.Save()
#Else
			ApplicationData.Current.RoamingSettings.Values(key) = value
#End If ' WINDOWS_PHONE
		End Sub

        Public Function TryGetValue(Of T)(ByVal key As String, <System.Runtime.InteropServices.Out> ByRef value As T) As Boolean Implements ISettings.TryGetValue
#If WINDOWS_PHONE Then
			Return IsolatedStorageSettings.ApplicationSettings.TryGetValue(Of T)(key, value)
#Else
            Dim result As Boolean = False
            If ApplicationData.Current.RoamingSettings.Values.ContainsKey(key) Then
                value = CType(ApplicationData.Current.RoamingSettings.Values(key), T)
                result = True
            Else
                value = Nothing
            End If

            Return result
#End If ' WINDOWS_PHONE
        End Function


		Public Function Remove(ByVal key As String) As Boolean Implements ISettings.Remove
#If WINDOWS_PHONE Then
			Dim result = IsolatedStorageSettings.ApplicationSettings.Remove(key)
			IsolatedStorageSettings.ApplicationSettings.Save()
			Return result
#Else
			Return ApplicationData.Current.RoamingSettings.Values.Remove(key)
#End If ' WINDOWS_PHONE
		End Function

		Public Function ContainsKey(ByVal key As String) As Boolean Implements ISettings.ContainsKey
#If WINDOWS_PHONE Then
			Return IsolatedStorageSettings.ApplicationSettings.Contains(key)
#Else
			Return ApplicationData.Current.RoamingSettings.Values.ContainsKey(key)
#End If ' WINDOWS_PHONE
		End Function
	End Class
End Namespace
