﻿Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports Windows.UI.ApplicationSettings
Imports System
Imports System.Collections.Generic

Namespace Charmed
    Public NotInheritable Class SettingsManager
        Implements ISettingsManager
        Private Property SettingsPane As SettingsPane

        Public Sub Initialize() Implements ISettingsManager.Initialize
            Me.SettingsPane = SettingsPane.GetForCurrentView
            AddHandler Me.SettingsPane.CommandsRequested, AddressOf SettingsPane_CommandsRequested
        End Sub

        Public Sub Cleanup() Implements ISettingsManager.Cleanup
            RemoveHandler Me.SettingsPane.CommandsRequested, AddressOf SettingsPane_CommandsRequested
        End Sub

        Private Sub SettingsPane_CommandsRequested(ByVal sender As SettingsPane, ByVal args As SettingsPaneCommandsRequestedEventArgs)
            If Me.OnSettingsRequested IsNot Nothing Then
                Me.OnSettingsRequested()(args.Request.ApplicationCommands)
            End If
        End Sub

        Public Property OnSettingsRequested As Action(Of IList(Of SettingsCommand)) Implements ISettingsManager.OnSettingsRequested
    End Class
End Namespace
