﻿Imports Windows.ApplicationModel.DataTransfer
Imports System

Namespace Charmed
    Public NotInheritable Class ShareManager
        Implements IShareManager
        Private Property DataTransferManager As DataTransferManager

        Public Sub Initialize() Implements IShareManager.Initialize
            Me.DataTransferManager = DataTransferManager.GetForCurrentView
            AddHandler Me.DataTransferManager.DataRequested, AddressOf DataTransferManager_DataRequested
        End Sub

        Public Sub Cleanup() Implements IShareManager.Cleanup
            RemoveHandler Me.DataTransferManager.DataRequested, AddressOf DataTransferManager_DataRequested
        End Sub

        Private Sub DataTransferManager_DataRequested(ByVal sender As DataTransferManager, ByVal args As DataRequestedEventArgs)
            If Me.OnShareRequested IsNot Nothing Then
                Me.OnShareRequested()(args.Request.Data)
            End If
        End Sub

        Public Property OnShareRequested As Action(Of DataPackage) Implements IShareManager.OnShareRequested
    End Class
End Namespace
